/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptation;

import edu.kit.ipd.descartes.core.CorePackage;

import edu.kit.ipd.descartes.identifier.IdentifierPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationFactory
 * @model kind="package"
 * @generated
 */
public interface AdaptationPackage extends EPackage {
    /**
	 * The package name.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    String eNAME = "adaptation";

    /**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    String eNS_URI = "http://www.descartes-research.net/metamodel/adaptation/0.1";

    /**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    String eNS_PREFIX = "adaptation";

    /**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    AdaptationPackage eINSTANCE = edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl.init();

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationProcessImpl <em>Process</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationProcessImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getAdaptationProcess()
	 * @generated
	 */
    int ADAPTATION_PROCESS = 0;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADAPTATION_PROCESS__ID = CorePackage.ENTITY__ID;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADAPTATION_PROCESS__NAME = CorePackage.ENTITY__NAME;

    /**
	 * The feature id for the '<em><b>Tactics</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADAPTATION_PROCESS__TACTICS = CorePackage.ENTITY_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Actions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADAPTATION_PROCESS__ACTIONS = CorePackage.ENTITY_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Strategies</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADAPTATION_PROCESS__STRATEGIES = CorePackage.ENTITY_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Parameters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADAPTATION_PROCESS__PARAMETERS = CorePackage.ENTITY_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Goal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADAPTATION_PROCESS__GOAL = CorePackage.ENTITY_FEATURE_COUNT + 4;

    /**
	 * The feature id for the '<em><b>Import Declaration</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADAPTATION_PROCESS__IMPORT_DECLARATION = CorePackage.ENTITY_FEATURE_COUNT + 5;

    /**
	 * The number of structural features of the '<em>Process</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADAPTATION_PROCESS_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 6;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.OverallGoalImpl <em>Overall Goal</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.OverallGoalImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getOverallGoal()
	 * @generated
	 */
    int OVERALL_GOAL = 1;

    /**
	 * The feature id for the '<em><b>Objectives</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OVERALL_GOAL__OBJECTIVES = 0;

    /**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OVERALL_GOAL__DESCRIPTION = 1;

    /**
	 * The number of structural features of the '<em>Overall Goal</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OVERALL_GOAL_FEATURE_COUNT = 2;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.StrategyImpl <em>Strategy</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.StrategyImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getStrategy()
	 * @generated
	 */
    int STRATEGY = 2;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int STRATEGY__ID = CorePackage.ENTITY__ID;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int STRATEGY__NAME = CorePackage.ENTITY__NAME;

    /**
	 * The feature id for the '<em><b>Objective</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int STRATEGY__OBJECTIVE = CorePackage.ENTITY_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Triggering Events</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int STRATEGY__TRIGGERING_EVENTS = CorePackage.ENTITY_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Tactics</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int STRATEGY__TACTICS = CorePackage.ENTITY_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Weighting Function</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int STRATEGY__WEIGHTING_FUNCTION = CorePackage.ENTITY_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Strategy</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int STRATEGY_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 4;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.EventImpl <em>Event</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.EventImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getEvent()
	 * @generated
	 */
    int EVENT = 3;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EVENT__ID = CorePackage.ENTITY__ID;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EVENT__NAME = CorePackage.ENTITY__NAME;

    /**
	 * The feature id for the '<em><b>Triggers</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EVENT__TRIGGERS = CorePackage.ENTITY_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Event</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int EVENT_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 1;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.ObjectiveImpl <em>Objective</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.ObjectiveImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getObjective()
	 * @generated
	 */
    int OBJECTIVE = 4;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OBJECTIVE__ID = CorePackage.ENTITY__ID;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OBJECTIVE__NAME = CorePackage.ENTITY__NAME;

    /**
	 * The feature id for the '<em><b>Specifications</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OBJECTIVE__SPECIFICATIONS = CorePackage.ENTITY_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Objective</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int OBJECTIVE_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 1;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.SpecificationImpl <em>Specification</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.SpecificationImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getSpecification()
	 * @generated
	 */
    int SPECIFICATION = 5;

    /**
	 * The feature id for the '<em><b>Metric Type</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SPECIFICATION__METRIC_TYPE = 0;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SPECIFICATION__VALUE = 1;

    /**
	 * The feature id for the '<em><b>Relational Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SPECIFICATION__RELATIONAL_OPERATOR = 2;

    /**
	 * The number of structural features of the '<em>Specification</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int SPECIFICATION_FEATURE_COUNT = 3;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.WeightingFunctionImpl <em>Weighting Function</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.WeightingFunctionImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getWeightingFunction()
	 * @generated
	 */
    int WEIGHTING_FUNCTION = 6;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTING_FUNCTION__ID = CorePackage.ENTITY__ID;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTING_FUNCTION__NAME = CorePackage.ENTITY__NAME;

    /**
	 * The feature id for the '<em><b>Weighted Metrics</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTING_FUNCTION__WEIGHTED_METRICS = CorePackage.ENTITY_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Weighting Function Implementation</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTING_FUNCTION__WEIGHTING_FUNCTION_IMPLEMENTATION = CorePackage.ENTITY_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Weighting Function</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTING_FUNCTION_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.WeightedMetricImpl <em>Weighted Metric</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.WeightedMetricImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getWeightedMetric()
	 * @generated
	 */
    int WEIGHTED_METRIC = 7;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTED_METRIC__ID = CorePackage.ENTITY__ID;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTED_METRIC__NAME = CorePackage.ENTITY__NAME;

    /**
	 * The feature id for the '<em><b>Weight</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTED_METRIC__WEIGHT = CorePackage.ENTITY_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Metric Type</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTED_METRIC__METRIC_TYPE = CorePackage.ENTITY_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Weighted Metric</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTED_METRIC_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.WeightedTacticImpl <em>Weighted Tactic</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.WeightedTacticImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getWeightedTactic()
	 * @generated
	 */
    int WEIGHTED_TACTIC = 8;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTED_TACTIC__ID = CorePackage.ENTITY__ID;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTED_TACTIC__NAME = CorePackage.ENTITY__NAME;

    /**
	 * The feature id for the '<em><b>Used Tactic</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTED_TACTIC__USED_TACTIC = CorePackage.ENTITY_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Current Weight</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTED_TACTIC__CURRENT_WEIGHT = CorePackage.ENTITY_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Default Weight</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTED_TACTIC__DEFAULT_WEIGHT = CorePackage.ENTITY_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Last Impact</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTED_TACTIC__LAST_IMPACT = CorePackage.ENTITY_FEATURE_COUNT + 3;

    /**
	 * The feature id for the '<em><b>Parent Strategy</b></em>' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTED_TACTIC__PARENT_STRATEGY = CorePackage.ENTITY_FEATURE_COUNT + 4;

    /**
	 * The number of structural features of the '<em>Weighted Tactic</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int WEIGHTED_TACTIC_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 5;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.TacticImpl <em>Tactic</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.TacticImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getTactic()
	 * @generated
	 */
    int TACTIC = 9;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TACTIC__ID = CorePackage.ENTITY__ID;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TACTIC__NAME = CorePackage.ENTITY__NAME;

    /**
	 * The feature id for the '<em><b>Implemented Plan</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TACTIC__IMPLEMENTED_PLAN = CorePackage.ENTITY_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Input Params</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TACTIC__INPUT_PARAMS = CorePackage.ENTITY_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Output Param</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TACTIC__OUTPUT_PARAM = CorePackage.ENTITY_FEATURE_COUNT + 2;

    /**
	 * The number of structural features of the '<em>Tactic</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int TACTIC_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 3;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.AbstractControlFlowElementImpl <em>Abstract Control Flow Element</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AbstractControlFlowElementImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getAbstractControlFlowElement()
	 * @generated
	 */
    int ABSTRACT_CONTROL_FLOW_ELEMENT = 10;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONTROL_FLOW_ELEMENT__ID = IdentifierPackage.IDENTIFIER__ID;

    /**
	 * The feature id for the '<em><b>Predecessor</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONTROL_FLOW_ELEMENT__PREDECESSOR = IdentifierPackage.IDENTIFIER_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Successor</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONTROL_FLOW_ELEMENT__SUCCESSOR = IdentifierPackage.IDENTIFIER_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Abstract Control Flow Element</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ABSTRACT_CONTROL_FLOW_ELEMENT_FEATURE_COUNT = IdentifierPackage.IDENTIFIER_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.StartActionImpl <em>Start Action</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.StartActionImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getStartAction()
	 * @generated
	 */
    int START_ACTION = 11;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int START_ACTION__ID = ABSTRACT_CONTROL_FLOW_ELEMENT__ID;

    /**
	 * The feature id for the '<em><b>Predecessor</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int START_ACTION__PREDECESSOR = ABSTRACT_CONTROL_FLOW_ELEMENT__PREDECESSOR;

    /**
	 * The feature id for the '<em><b>Successor</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int START_ACTION__SUCCESSOR = ABSTRACT_CONTROL_FLOW_ELEMENT__SUCCESSOR;

    /**
	 * The number of structural features of the '<em>Start Action</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int START_ACTION_FEATURE_COUNT = ABSTRACT_CONTROL_FLOW_ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.StopActionImpl <em>Stop Action</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.StopActionImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getStopAction()
	 * @generated
	 */
    int STOP_ACTION = 12;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int STOP_ACTION__ID = ABSTRACT_CONTROL_FLOW_ELEMENT__ID;

    /**
	 * The feature id for the '<em><b>Predecessor</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int STOP_ACTION__PREDECESSOR = ABSTRACT_CONTROL_FLOW_ELEMENT__PREDECESSOR;

    /**
	 * The feature id for the '<em><b>Successor</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int STOP_ACTION__SUCCESSOR = ABSTRACT_CONTROL_FLOW_ELEMENT__SUCCESSOR;

    /**
	 * The number of structural features of the '<em>Stop Action</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int STOP_ACTION_FEATURE_COUNT = ABSTRACT_CONTROL_FLOW_ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.LoopActionImpl <em>Loop Action</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.LoopActionImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getLoopAction()
	 * @generated
	 */
    int LOOP_ACTION = 13;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOOP_ACTION__ID = ABSTRACT_CONTROL_FLOW_ELEMENT__ID;

    /**
	 * The feature id for the '<em><b>Predecessor</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOOP_ACTION__PREDECESSOR = ABSTRACT_CONTROL_FLOW_ELEMENT__PREDECESSOR;

    /**
	 * The feature id for the '<em><b>Successor</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOOP_ACTION__SUCCESSOR = ABSTRACT_CONTROL_FLOW_ELEMENT__SUCCESSOR;

    /**
	 * The feature id for the '<em><b>Counter</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOOP_ACTION__COUNTER = ABSTRACT_CONTROL_FLOW_ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Body</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOOP_ACTION__BODY = ABSTRACT_CONTROL_FLOW_ELEMENT_FEATURE_COUNT + 1;

    /**
	 * The number of structural features of the '<em>Loop Action</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int LOOP_ACTION_FEATURE_COUNT = ABSTRACT_CONTROL_FLOW_ELEMENT_FEATURE_COUNT + 2;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.BranchActionImpl <em>Branch Action</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.BranchActionImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getBranchAction()
	 * @generated
	 */
    int BRANCH_ACTION = 14;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BRANCH_ACTION__ID = ABSTRACT_CONTROL_FLOW_ELEMENT__ID;

    /**
	 * The feature id for the '<em><b>Predecessor</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BRANCH_ACTION__PREDECESSOR = ABSTRACT_CONTROL_FLOW_ELEMENT__PREDECESSOR;

    /**
	 * The feature id for the '<em><b>Successor</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BRANCH_ACTION__SUCCESSOR = ABSTRACT_CONTROL_FLOW_ELEMENT__SUCCESSOR;

    /**
	 * The feature id for the '<em><b>Context</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BRANCH_ACTION__CONTEXT = ABSTRACT_CONTROL_FLOW_ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Condition</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BRANCH_ACTION__CONDITION = ABSTRACT_CONTROL_FLOW_ELEMENT_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Condition True Branch</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BRANCH_ACTION__CONDITION_TRUE_BRANCH = ABSTRACT_CONTROL_FLOW_ELEMENT_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Condition False Branch</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BRANCH_ACTION__CONDITION_FALSE_BRANCH = ABSTRACT_CONTROL_FLOW_ELEMENT_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Branch Action</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int BRANCH_ACTION_FEATURE_COUNT = ABSTRACT_CONTROL_FLOW_ELEMENT_FEATURE_COUNT + 4;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.ActionReferenceImpl <em>Action Reference</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.ActionReferenceImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getActionReference()
	 * @generated
	 */
    int ACTION_REFERENCE = 15;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACTION_REFERENCE__ID = ABSTRACT_CONTROL_FLOW_ELEMENT__ID;

    /**
	 * The feature id for the '<em><b>Predecessor</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACTION_REFERENCE__PREDECESSOR = ABSTRACT_CONTROL_FLOW_ELEMENT__PREDECESSOR;

    /**
	 * The feature id for the '<em><b>Successor</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACTION_REFERENCE__SUCCESSOR = ABSTRACT_CONTROL_FLOW_ELEMENT__SUCCESSOR;

    /**
	 * The feature id for the '<em><b>Refers To</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACTION_REFERENCE__REFERS_TO = ABSTRACT_CONTROL_FLOW_ELEMENT_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Action Reference</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACTION_REFERENCE_FEATURE_COUNT = ABSTRACT_CONTROL_FLOW_ELEMENT_FEATURE_COUNT + 1;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPlanImpl <em>Plan</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPlanImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getAdaptationPlan()
	 * @generated
	 */
    int ADAPTATION_PLAN = 16;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADAPTATION_PLAN__ID = CorePackage.ENTITY__ID;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADAPTATION_PLAN__NAME = CorePackage.ENTITY__NAME;

    /**
	 * The feature id for the '<em><b>Steps</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADAPTATION_PLAN__STEPS = CorePackage.ENTITY_FEATURE_COUNT + 0;

    /**
	 * The number of structural features of the '<em>Plan</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADAPTATION_PLAN_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 1;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.ActionImpl <em>Action</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.ActionImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getAction()
	 * @generated
	 */
    int ACTION = 17;

    /**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACTION__ID = CorePackage.ENTITY__ID;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACTION__NAME = CorePackage.ENTITY__NAME;

    /**
	 * The feature id for the '<em><b>Output Param</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACTION__OUTPUT_PARAM = CorePackage.ENTITY_FEATURE_COUNT + 0;

    /**
	 * The feature id for the '<em><b>Input Params</b></em>' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACTION__INPUT_PARAMS = CorePackage.ENTITY_FEATURE_COUNT + 1;

    /**
	 * The feature id for the '<em><b>Referred Adaptation Point</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACTION__REFERRED_ADAPTATION_POINT = CorePackage.ENTITY_FEATURE_COUNT + 2;

    /**
	 * The feature id for the '<em><b>Adaptation Action Operation</b></em>' containment reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACTION__ADAPTATION_ACTION_OPERATION = CorePackage.ENTITY_FEATURE_COUNT + 3;

    /**
	 * The number of structural features of the '<em>Action</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ACTION_FEATURE_COUNT = CorePackage.ENTITY_FEATURE_COUNT + 4;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationActionOperationImpl <em>Action Operation</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationActionOperationImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getAdaptationActionOperation()
	 * @generated
	 */
    int ADAPTATION_ACTION_OPERATION = 18;

    /**
	 * The feature id for the '<em><b>Adaptation Operation Scope</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADAPTATION_ACTION_OPERATION__ADAPTATION_OPERATION_SCOPE = 0;

    /**
	 * The feature id for the '<em><b>Adaptation Operation Direction</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADAPTATION_ACTION_OPERATION__ADAPTATION_OPERATION_DIRECTION = 1;

    /**
	 * The number of structural features of the '<em>Action Operation</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int ADAPTATION_ACTION_OPERATION_FEATURE_COUNT = 2;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.ParameterImpl <em>Parameter</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.ParameterImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getParameter()
	 * @generated
	 */
    int PARAMETER = 19;

    /**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PARAMETER__NAME = 0;

    /**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PARAMETER__TYPE = 1;

    /**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PARAMETER__VALUE = 2;

    /**
	 * The number of structural features of the '<em>Parameter</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int PARAMETER_FEATURE_COUNT = 3;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.ImportDeclarationImpl <em>Import Declaration</em>}' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.ImportDeclarationImpl
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getImportDeclaration()
	 * @generated
	 */
    int IMPORT_DECLARATION = 20;

    /**
	 * The feature id for the '<em><b>Import URI</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IMPORT_DECLARATION__IMPORT_URI = 0;

    /**
	 * The number of structural features of the '<em>Import Declaration</em>' class.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
    int IMPORT_DECLARATION_FEATURE_COUNT = 1;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationScope <em>Scope</em>}' enum.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationScope
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getAdaptationScope()
	 * @generated
	 */
    int ADAPTATION_SCOPE = 21;

    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationDirection <em>Direction</em>}' enum.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationDirection
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getAdaptationDirection()
	 * @generated
	 */
    int ADAPTATION_DIRECTION = 22;


    /**
	 * The meta object id for the '{@link edu.kit.ipd.descartes.mm.adaptation.RelationalOperator <em>Relational Operator</em>}' enum.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see edu.kit.ipd.descartes.mm.adaptation.RelationalOperator
	 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getRelationalOperator()
	 * @generated
	 */
    int RELATIONAL_OPERATOR = 23;


    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess <em>Process</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess
	 * @generated
	 */
    EClass getAdaptationProcess();

    /**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess#getTactics <em>Tactics</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Tactics</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess#getTactics()
	 * @see #getAdaptationProcess()
	 * @generated
	 */
    EReference getAdaptationProcess_Tactics();

    /**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess#getActions <em>Actions</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Actions</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess#getActions()
	 * @see #getAdaptationProcess()
	 * @generated
	 */
    EReference getAdaptationProcess_Actions();

    /**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess#getStrategies <em>Strategies</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Strategies</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess#getStrategies()
	 * @see #getAdaptationProcess()
	 * @generated
	 */
    EReference getAdaptationProcess_Strategies();

    /**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess#getParameters <em>Parameters</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Parameters</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess#getParameters()
	 * @see #getAdaptationProcess()
	 * @generated
	 */
    EReference getAdaptationProcess_Parameters();

    /**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess#getGoal <em>Goal</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Goal</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess#getGoal()
	 * @see #getAdaptationProcess()
	 * @generated
	 */
    EReference getAdaptationProcess_Goal();

    /**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess#getImportDeclaration <em>Import Declaration</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Import Declaration</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess#getImportDeclaration()
	 * @see #getAdaptationProcess()
	 * @generated
	 */
    EReference getAdaptationProcess_ImportDeclaration();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.OverallGoal <em>Overall Goal</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Overall Goal</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.OverallGoal
	 * @generated
	 */
    EClass getOverallGoal();

    /**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.adaptation.OverallGoal#getObjectives <em>Objectives</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Objectives</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.OverallGoal#getObjectives()
	 * @see #getOverallGoal()
	 * @generated
	 */
    EReference getOverallGoal_Objectives();

    /**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.adaptation.OverallGoal#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.OverallGoal#getDescription()
	 * @see #getOverallGoal()
	 * @generated
	 */
    EAttribute getOverallGoal_Description();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.Strategy <em>Strategy</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Strategy</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Strategy
	 * @generated
	 */
    EClass getStrategy();

    /**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.adaptation.Strategy#getObjective <em>Objective</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Objective</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Strategy#getObjective()
	 * @see #getStrategy()
	 * @generated
	 */
    EReference getStrategy_Objective();

    /**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.adaptation.Strategy#getTriggeringEvents <em>Triggering Events</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Triggering Events</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Strategy#getTriggeringEvents()
	 * @see #getStrategy()
	 * @generated
	 */
    EReference getStrategy_TriggeringEvents();

    /**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.adaptation.Strategy#getTactics <em>Tactics</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Tactics</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Strategy#getTactics()
	 * @see #getStrategy()
	 * @generated
	 */
    EReference getStrategy_Tactics();

    /**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.adaptation.Strategy#getWeightingFunction <em>Weighting Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Weighting Function</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Strategy#getWeightingFunction()
	 * @see #getStrategy()
	 * @generated
	 */
    EReference getStrategy_WeightingFunction();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.Event <em>Event</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Event
	 * @generated
	 */
    EClass getEvent();

    /**
	 * Returns the meta object for the container reference '{@link edu.kit.ipd.descartes.mm.adaptation.Event#getTriggers <em>Triggers</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Triggers</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Event#getTriggers()
	 * @see #getEvent()
	 * @generated
	 */
    EReference getEvent_Triggers();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.Objective <em>Objective</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Objective</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Objective
	 * @generated
	 */
    EClass getObjective();

    /**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.adaptation.Objective#getSpecifications <em>Specifications</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Specifications</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Objective#getSpecifications()
	 * @see #getObjective()
	 * @generated
	 */
    EReference getObjective_Specifications();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.Specification <em>Specification</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Specification</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Specification
	 * @generated
	 */
    EClass getSpecification();

    /**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.adaptation.Specification#getMetricType <em>Metric Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Metric Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Specification#getMetricType()
	 * @see #getSpecification()
	 * @generated
	 */
    EReference getSpecification_MetricType();

    /**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.adaptation.Specification#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Specification#getValue()
	 * @see #getSpecification()
	 * @generated
	 */
    EAttribute getSpecification_Value();

    /**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.adaptation.Specification#getRelationalOperator <em>Relational Operator</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Relational Operator</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Specification#getRelationalOperator()
	 * @see #getSpecification()
	 * @generated
	 */
    EAttribute getSpecification_RelationalOperator();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.WeightingFunction <em>Weighting Function</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Weighting Function</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.WeightingFunction
	 * @generated
	 */
    EClass getWeightingFunction();

    /**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.adaptation.WeightingFunction#getWeightedMetrics <em>Weighted Metrics</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Weighted Metrics</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.WeightingFunction#getWeightedMetrics()
	 * @see #getWeightingFunction()
	 * @generated
	 */
    EReference getWeightingFunction_WeightedMetrics();

    /**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.adaptation.WeightingFunction#getWeightingFunctionImplementation <em>Weighting Function Implementation</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Weighting Function Implementation</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.WeightingFunction#getWeightingFunctionImplementation()
	 * @see #getWeightingFunction()
	 * @generated
	 */
    EAttribute getWeightingFunction_WeightingFunctionImplementation();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.WeightedMetric <em>Weighted Metric</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Weighted Metric</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.WeightedMetric
	 * @generated
	 */
    EClass getWeightedMetric();

    /**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.adaptation.WeightedMetric#getWeight <em>Weight</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Weight</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.WeightedMetric#getWeight()
	 * @see #getWeightedMetric()
	 * @generated
	 */
    EAttribute getWeightedMetric_Weight();

    /**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.adaptation.WeightedMetric#getMetricType <em>Metric Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Metric Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.WeightedMetric#getMetricType()
	 * @see #getWeightedMetric()
	 * @generated
	 */
    EReference getWeightedMetric_MetricType();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic <em>Weighted Tactic</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Weighted Tactic</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.WeightedTactic
	 * @generated
	 */
    EClass getWeightedTactic();

    /**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getUsedTactic <em>Used Tactic</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Used Tactic</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getUsedTactic()
	 * @see #getWeightedTactic()
	 * @generated
	 */
    EReference getWeightedTactic_UsedTactic();

    /**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getCurrentWeight <em>Current Weight</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Current Weight</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getCurrentWeight()
	 * @see #getWeightedTactic()
	 * @generated
	 */
    EAttribute getWeightedTactic_CurrentWeight();

    /**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getDefaultWeight <em>Default Weight</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Default Weight</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getDefaultWeight()
	 * @see #getWeightedTactic()
	 * @generated
	 */
    EAttribute getWeightedTactic_DefaultWeight();

    /**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getLastImpact <em>Last Impact</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Last Impact</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getLastImpact()
	 * @see #getWeightedTactic()
	 * @generated
	 */
    EReference getWeightedTactic_LastImpact();

    /**
	 * Returns the meta object for the container reference '{@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getParentStrategy <em>Parent Strategy</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent Strategy</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getParentStrategy()
	 * @see #getWeightedTactic()
	 * @generated
	 */
    EReference getWeightedTactic_ParentStrategy();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.Tactic <em>Tactic</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Tactic</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Tactic
	 * @generated
	 */
    EClass getTactic();

    /**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.adaptation.Tactic#getImplementedPlan <em>Implemented Plan</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Implemented Plan</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Tactic#getImplementedPlan()
	 * @see #getTactic()
	 * @generated
	 */
    EReference getTactic_ImplementedPlan();

    /**
	 * Returns the meta object for the reference list '{@link edu.kit.ipd.descartes.mm.adaptation.Tactic#getInputParams <em>Input Params</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Input Params</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Tactic#getInputParams()
	 * @see #getTactic()
	 * @generated
	 */
    EReference getTactic_InputParams();

    /**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.adaptation.Tactic#getOutputParam <em>Output Param</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Output Param</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Tactic#getOutputParam()
	 * @see #getTactic()
	 * @generated
	 */
    EReference getTactic_OutputParam();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.AbstractControlFlowElement <em>Abstract Control Flow Element</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Control Flow Element</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AbstractControlFlowElement
	 * @generated
	 */
    EClass getAbstractControlFlowElement();

    /**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.adaptation.AbstractControlFlowElement#getPredecessor <em>Predecessor</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Predecessor</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AbstractControlFlowElement#getPredecessor()
	 * @see #getAbstractControlFlowElement()
	 * @generated
	 */
    EReference getAbstractControlFlowElement_Predecessor();

    /**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.adaptation.AbstractControlFlowElement#getSuccessor <em>Successor</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Successor</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AbstractControlFlowElement#getSuccessor()
	 * @see #getAbstractControlFlowElement()
	 * @generated
	 */
    EReference getAbstractControlFlowElement_Successor();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.StartAction <em>Start Action</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Start Action</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.StartAction
	 * @generated
	 */
    EClass getStartAction();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.StopAction <em>Stop Action</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Stop Action</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.StopAction
	 * @generated
	 */
    EClass getStopAction();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.LoopAction <em>Loop Action</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Loop Action</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.LoopAction
	 * @generated
	 */
    EClass getLoopAction();

    /**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.adaptation.LoopAction#getCounter <em>Counter</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Counter</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.LoopAction#getCounter()
	 * @see #getLoopAction()
	 * @generated
	 */
    EReference getLoopAction_Counter();

    /**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.adaptation.LoopAction#getBody <em>Body</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Body</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.LoopAction#getBody()
	 * @see #getLoopAction()
	 * @generated
	 */
    EReference getLoopAction_Body();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.BranchAction <em>Branch Action</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Branch Action</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.BranchAction
	 * @generated
	 */
    EClass getBranchAction();

    /**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.adaptation.BranchAction#getContext <em>Context</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Context</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.BranchAction#getContext()
	 * @see #getBranchAction()
	 * @generated
	 */
    EReference getBranchAction_Context();

    /**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.adaptation.BranchAction#getCondition <em>Condition</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Condition</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.BranchAction#getCondition()
	 * @see #getBranchAction()
	 * @generated
	 */
    EAttribute getBranchAction_Condition();

    /**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.adaptation.BranchAction#getConditionTrueBranch <em>Condition True Branch</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Condition True Branch</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.BranchAction#getConditionTrueBranch()
	 * @see #getBranchAction()
	 * @generated
	 */
    EReference getBranchAction_ConditionTrueBranch();

    /**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.adaptation.BranchAction#getConditionFalseBranch <em>Condition False Branch</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Condition False Branch</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.BranchAction#getConditionFalseBranch()
	 * @see #getBranchAction()
	 * @generated
	 */
    EReference getBranchAction_ConditionFalseBranch();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.ActionReference <em>Action Reference</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Action Reference</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.ActionReference
	 * @generated
	 */
    EClass getActionReference();

    /**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.adaptation.ActionReference#getRefersTo <em>Refers To</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Refers To</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.ActionReference#getRefersTo()
	 * @see #getActionReference()
	 * @generated
	 */
    EReference getActionReference_RefersTo();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationPlan <em>Plan</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Plan</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationPlan
	 * @generated
	 */
    EClass getAdaptationPlan();

    /**
	 * Returns the meta object for the containment reference list '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationPlan#getSteps <em>Steps</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Steps</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationPlan#getSteps()
	 * @see #getAdaptationPlan()
	 * @generated
	 */
    EReference getAdaptationPlan_Steps();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.Action <em>Action</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Action</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Action
	 * @generated
	 */
    EClass getAction();

    /**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.adaptation.Action#getOutputParam <em>Output Param</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Output Param</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Action#getOutputParam()
	 * @see #getAction()
	 * @generated
	 */
    EReference getAction_OutputParam();

    /**
	 * Returns the meta object for the reference list '{@link edu.kit.ipd.descartes.mm.adaptation.Action#getInputParams <em>Input Params</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Input Params</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Action#getInputParams()
	 * @see #getAction()
	 * @generated
	 */
    EReference getAction_InputParams();

    /**
	 * Returns the meta object for the reference '{@link edu.kit.ipd.descartes.mm.adaptation.Action#getReferredAdaptationPoint <em>Referred Adaptation Point</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Referred Adaptation Point</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Action#getReferredAdaptationPoint()
	 * @see #getAction()
	 * @generated
	 */
    EReference getAction_ReferredAdaptationPoint();

    /**
	 * Returns the meta object for the containment reference '{@link edu.kit.ipd.descartes.mm.adaptation.Action#getAdaptationActionOperation <em>Adaptation Action Operation</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Adaptation Action Operation</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Action#getAdaptationActionOperation()
	 * @see #getAction()
	 * @generated
	 */
    EReference getAction_AdaptationActionOperation();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationActionOperation <em>Action Operation</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Action Operation</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationActionOperation
	 * @generated
	 */
    EClass getAdaptationActionOperation();

    /**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationActionOperation#getAdaptationOperationScope <em>Adaptation Operation Scope</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Adaptation Operation Scope</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationActionOperation#getAdaptationOperationScope()
	 * @see #getAdaptationActionOperation()
	 * @generated
	 */
    EAttribute getAdaptationActionOperation_AdaptationOperationScope();

    /**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationActionOperation#getAdaptationOperationDirection <em>Adaptation Operation Direction</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Adaptation Operation Direction</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationActionOperation#getAdaptationOperationDirection()
	 * @see #getAdaptationActionOperation()
	 * @generated
	 */
    EAttribute getAdaptationActionOperation_AdaptationOperationDirection();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.Parameter <em>Parameter</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Parameter</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Parameter
	 * @generated
	 */
    EClass getParameter();

    /**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.adaptation.Parameter#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Parameter#getName()
	 * @see #getParameter()
	 * @generated
	 */
    EAttribute getParameter_Name();

    /**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.adaptation.Parameter#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Parameter#getType()
	 * @see #getParameter()
	 * @generated
	 */
    EAttribute getParameter_Type();

    /**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.adaptation.Parameter#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.Parameter#getValue()
	 * @see #getParameter()
	 * @generated
	 */
    EAttribute getParameter_Value();

    /**
	 * Returns the meta object for class '{@link edu.kit.ipd.descartes.mm.adaptation.ImportDeclaration <em>Import Declaration</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Import Declaration</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.ImportDeclaration
	 * @generated
	 */
    EClass getImportDeclaration();

    /**
	 * Returns the meta object for the attribute '{@link edu.kit.ipd.descartes.mm.adaptation.ImportDeclaration#getImportURI <em>Import URI</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Import URI</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.ImportDeclaration#getImportURI()
	 * @see #getImportDeclaration()
	 * @generated
	 */
    EAttribute getImportDeclaration_ImportURI();

    /**
	 * Returns the meta object for enum '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationScope <em>Scope</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Scope</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationScope
	 * @generated
	 */
    EEnum getAdaptationScope();

    /**
	 * Returns the meta object for enum '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationDirection <em>Direction</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Direction</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationDirection
	 * @generated
	 */
    EEnum getAdaptationDirection();

    /**
	 * Returns the meta object for enum '{@link edu.kit.ipd.descartes.mm.adaptation.RelationalOperator <em>Relational Operator</em>}'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Relational Operator</em>'.
	 * @see edu.kit.ipd.descartes.mm.adaptation.RelationalOperator
	 * @generated
	 */
    EEnum getRelationalOperator();

    /**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
    AdaptationFactory getAdaptationFactory();

    /**
	 * <!-- begin-user-doc -->
     * Defines literals for the meta objects that represent
     * <ul>
     *   <li>each class,</li>
     *   <li>each feature of each class,</li>
     *   <li>each enum,</li>
     *   <li>and each data type</li>
     * </ul>
     * <!-- end-user-doc -->
	 * @generated
	 */
    interface Literals {
        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationProcessImpl <em>Process</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationProcessImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getAdaptationProcess()
		 * @generated
		 */
        EClass ADAPTATION_PROCESS = eINSTANCE.getAdaptationProcess();

        /**
		 * The meta object literal for the '<em><b>Tactics</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference ADAPTATION_PROCESS__TACTICS = eINSTANCE.getAdaptationProcess_Tactics();

        /**
		 * The meta object literal for the '<em><b>Actions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference ADAPTATION_PROCESS__ACTIONS = eINSTANCE.getAdaptationProcess_Actions();

        /**
		 * The meta object literal for the '<em><b>Strategies</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference ADAPTATION_PROCESS__STRATEGIES = eINSTANCE.getAdaptationProcess_Strategies();

        /**
		 * The meta object literal for the '<em><b>Parameters</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference ADAPTATION_PROCESS__PARAMETERS = eINSTANCE.getAdaptationProcess_Parameters();

        /**
		 * The meta object literal for the '<em><b>Goal</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference ADAPTATION_PROCESS__GOAL = eINSTANCE.getAdaptationProcess_Goal();

        /**
		 * The meta object literal for the '<em><b>Import Declaration</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference ADAPTATION_PROCESS__IMPORT_DECLARATION = eINSTANCE.getAdaptationProcess_ImportDeclaration();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.OverallGoalImpl <em>Overall Goal</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.OverallGoalImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getOverallGoal()
		 * @generated
		 */
        EClass OVERALL_GOAL = eINSTANCE.getOverallGoal();

        /**
		 * The meta object literal for the '<em><b>Objectives</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference OVERALL_GOAL__OBJECTIVES = eINSTANCE.getOverallGoal_Objectives();

        /**
		 * The meta object literal for the '<em><b>Description</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute OVERALL_GOAL__DESCRIPTION = eINSTANCE.getOverallGoal_Description();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.StrategyImpl <em>Strategy</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.StrategyImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getStrategy()
		 * @generated
		 */
        EClass STRATEGY = eINSTANCE.getStrategy();

        /**
		 * The meta object literal for the '<em><b>Objective</b></em>' reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference STRATEGY__OBJECTIVE = eINSTANCE.getStrategy_Objective();

        /**
		 * The meta object literal for the '<em><b>Triggering Events</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference STRATEGY__TRIGGERING_EVENTS = eINSTANCE.getStrategy_TriggeringEvents();

        /**
		 * The meta object literal for the '<em><b>Tactics</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference STRATEGY__TACTICS = eINSTANCE.getStrategy_Tactics();

        /**
		 * The meta object literal for the '<em><b>Weighting Function</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference STRATEGY__WEIGHTING_FUNCTION = eINSTANCE.getStrategy_WeightingFunction();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.EventImpl <em>Event</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.EventImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getEvent()
		 * @generated
		 */
        EClass EVENT = eINSTANCE.getEvent();

        /**
		 * The meta object literal for the '<em><b>Triggers</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference EVENT__TRIGGERS = eINSTANCE.getEvent_Triggers();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.ObjectiveImpl <em>Objective</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.ObjectiveImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getObjective()
		 * @generated
		 */
        EClass OBJECTIVE = eINSTANCE.getObjective();

        /**
		 * The meta object literal for the '<em><b>Specifications</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference OBJECTIVE__SPECIFICATIONS = eINSTANCE.getObjective_Specifications();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.SpecificationImpl <em>Specification</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.SpecificationImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getSpecification()
		 * @generated
		 */
        EClass SPECIFICATION = eINSTANCE.getSpecification();

        /**
		 * The meta object literal for the '<em><b>Metric Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference SPECIFICATION__METRIC_TYPE = eINSTANCE.getSpecification_MetricType();

        /**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute SPECIFICATION__VALUE = eINSTANCE.getSpecification_Value();

        /**
		 * The meta object literal for the '<em><b>Relational Operator</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute SPECIFICATION__RELATIONAL_OPERATOR = eINSTANCE.getSpecification_RelationalOperator();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.WeightingFunctionImpl <em>Weighting Function</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.WeightingFunctionImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getWeightingFunction()
		 * @generated
		 */
        EClass WEIGHTING_FUNCTION = eINSTANCE.getWeightingFunction();

        /**
		 * The meta object literal for the '<em><b>Weighted Metrics</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference WEIGHTING_FUNCTION__WEIGHTED_METRICS = eINSTANCE.getWeightingFunction_WeightedMetrics();

        /**
		 * The meta object literal for the '<em><b>Weighting Function Implementation</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute WEIGHTING_FUNCTION__WEIGHTING_FUNCTION_IMPLEMENTATION = eINSTANCE.getWeightingFunction_WeightingFunctionImplementation();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.WeightedMetricImpl <em>Weighted Metric</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.WeightedMetricImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getWeightedMetric()
		 * @generated
		 */
        EClass WEIGHTED_METRIC = eINSTANCE.getWeightedMetric();

        /**
		 * The meta object literal for the '<em><b>Weight</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute WEIGHTED_METRIC__WEIGHT = eINSTANCE.getWeightedMetric_Weight();

        /**
		 * The meta object literal for the '<em><b>Metric Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference WEIGHTED_METRIC__METRIC_TYPE = eINSTANCE.getWeightedMetric_MetricType();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.WeightedTacticImpl <em>Weighted Tactic</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.WeightedTacticImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getWeightedTactic()
		 * @generated
		 */
        EClass WEIGHTED_TACTIC = eINSTANCE.getWeightedTactic();

        /**
		 * The meta object literal for the '<em><b>Used Tactic</b></em>' reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference WEIGHTED_TACTIC__USED_TACTIC = eINSTANCE.getWeightedTactic_UsedTactic();

        /**
		 * The meta object literal for the '<em><b>Current Weight</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute WEIGHTED_TACTIC__CURRENT_WEIGHT = eINSTANCE.getWeightedTactic_CurrentWeight();

        /**
		 * The meta object literal for the '<em><b>Default Weight</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute WEIGHTED_TACTIC__DEFAULT_WEIGHT = eINSTANCE.getWeightedTactic_DefaultWeight();

        /**
		 * The meta object literal for the '<em><b>Last Impact</b></em>' reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference WEIGHTED_TACTIC__LAST_IMPACT = eINSTANCE.getWeightedTactic_LastImpact();

        /**
		 * The meta object literal for the '<em><b>Parent Strategy</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference WEIGHTED_TACTIC__PARENT_STRATEGY = eINSTANCE.getWeightedTactic_ParentStrategy();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.TacticImpl <em>Tactic</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.TacticImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getTactic()
		 * @generated
		 */
        EClass TACTIC = eINSTANCE.getTactic();

        /**
		 * The meta object literal for the '<em><b>Implemented Plan</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference TACTIC__IMPLEMENTED_PLAN = eINSTANCE.getTactic_ImplementedPlan();

        /**
		 * The meta object literal for the '<em><b>Input Params</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference TACTIC__INPUT_PARAMS = eINSTANCE.getTactic_InputParams();

        /**
		 * The meta object literal for the '<em><b>Output Param</b></em>' reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference TACTIC__OUTPUT_PARAM = eINSTANCE.getTactic_OutputParam();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.AbstractControlFlowElementImpl <em>Abstract Control Flow Element</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AbstractControlFlowElementImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getAbstractControlFlowElement()
		 * @generated
		 */
        EClass ABSTRACT_CONTROL_FLOW_ELEMENT = eINSTANCE.getAbstractControlFlowElement();

        /**
		 * The meta object literal for the '<em><b>Predecessor</b></em>' reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference ABSTRACT_CONTROL_FLOW_ELEMENT__PREDECESSOR = eINSTANCE.getAbstractControlFlowElement_Predecessor();

        /**
		 * The meta object literal for the '<em><b>Successor</b></em>' reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference ABSTRACT_CONTROL_FLOW_ELEMENT__SUCCESSOR = eINSTANCE.getAbstractControlFlowElement_Successor();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.StartActionImpl <em>Start Action</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.StartActionImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getStartAction()
		 * @generated
		 */
        EClass START_ACTION = eINSTANCE.getStartAction();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.StopActionImpl <em>Stop Action</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.StopActionImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getStopAction()
		 * @generated
		 */
        EClass STOP_ACTION = eINSTANCE.getStopAction();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.LoopActionImpl <em>Loop Action</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.LoopActionImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getLoopAction()
		 * @generated
		 */
        EClass LOOP_ACTION = eINSTANCE.getLoopAction();

        /**
		 * The meta object literal for the '<em><b>Counter</b></em>' reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference LOOP_ACTION__COUNTER = eINSTANCE.getLoopAction_Counter();

        /**
		 * The meta object literal for the '<em><b>Body</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference LOOP_ACTION__BODY = eINSTANCE.getLoopAction_Body();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.BranchActionImpl <em>Branch Action</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.BranchActionImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getBranchAction()
		 * @generated
		 */
        EClass BRANCH_ACTION = eINSTANCE.getBranchAction();

        /**
		 * The meta object literal for the '<em><b>Context</b></em>' reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference BRANCH_ACTION__CONTEXT = eINSTANCE.getBranchAction_Context();

        /**
		 * The meta object literal for the '<em><b>Condition</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute BRANCH_ACTION__CONDITION = eINSTANCE.getBranchAction_Condition();

        /**
		 * The meta object literal for the '<em><b>Condition True Branch</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference BRANCH_ACTION__CONDITION_TRUE_BRANCH = eINSTANCE.getBranchAction_ConditionTrueBranch();

        /**
		 * The meta object literal for the '<em><b>Condition False Branch</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference BRANCH_ACTION__CONDITION_FALSE_BRANCH = eINSTANCE.getBranchAction_ConditionFalseBranch();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.ActionReferenceImpl <em>Action Reference</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.ActionReferenceImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getActionReference()
		 * @generated
		 */
        EClass ACTION_REFERENCE = eINSTANCE.getActionReference();

        /**
		 * The meta object literal for the '<em><b>Refers To</b></em>' reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference ACTION_REFERENCE__REFERS_TO = eINSTANCE.getActionReference_RefersTo();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPlanImpl <em>Plan</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPlanImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getAdaptationPlan()
		 * @generated
		 */
        EClass ADAPTATION_PLAN = eINSTANCE.getAdaptationPlan();

        /**
		 * The meta object literal for the '<em><b>Steps</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference ADAPTATION_PLAN__STEPS = eINSTANCE.getAdaptationPlan_Steps();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.ActionImpl <em>Action</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.ActionImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getAction()
		 * @generated
		 */
        EClass ACTION = eINSTANCE.getAction();

        /**
		 * The meta object literal for the '<em><b>Output Param</b></em>' reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference ACTION__OUTPUT_PARAM = eINSTANCE.getAction_OutputParam();

        /**
		 * The meta object literal for the '<em><b>Input Params</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference ACTION__INPUT_PARAMS = eINSTANCE.getAction_InputParams();

        /**
		 * The meta object literal for the '<em><b>Referred Adaptation Point</b></em>' reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference ACTION__REFERRED_ADAPTATION_POINT = eINSTANCE.getAction_ReferredAdaptationPoint();

        /**
		 * The meta object literal for the '<em><b>Adaptation Action Operation</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EReference ACTION__ADAPTATION_ACTION_OPERATION = eINSTANCE.getAction_AdaptationActionOperation();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationActionOperationImpl <em>Action Operation</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationActionOperationImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getAdaptationActionOperation()
		 * @generated
		 */
        EClass ADAPTATION_ACTION_OPERATION = eINSTANCE.getAdaptationActionOperation();

        /**
		 * The meta object literal for the '<em><b>Adaptation Operation Scope</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute ADAPTATION_ACTION_OPERATION__ADAPTATION_OPERATION_SCOPE = eINSTANCE.getAdaptationActionOperation_AdaptationOperationScope();

        /**
		 * The meta object literal for the '<em><b>Adaptation Operation Direction</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute ADAPTATION_ACTION_OPERATION__ADAPTATION_OPERATION_DIRECTION = eINSTANCE.getAdaptationActionOperation_AdaptationOperationDirection();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.ParameterImpl <em>Parameter</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.ParameterImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getParameter()
		 * @generated
		 */
        EClass PARAMETER = eINSTANCE.getParameter();

        /**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute PARAMETER__NAME = eINSTANCE.getParameter_Name();

        /**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute PARAMETER__TYPE = eINSTANCE.getParameter_Type();

        /**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute PARAMETER__VALUE = eINSTANCE.getParameter_Value();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.impl.ImportDeclarationImpl <em>Import Declaration</em>}' class.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.ImportDeclarationImpl
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getImportDeclaration()
		 * @generated
		 */
        EClass IMPORT_DECLARATION = eINSTANCE.getImportDeclaration();

        /**
		 * The meta object literal for the '<em><b>Import URI</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @generated
		 */
        EAttribute IMPORT_DECLARATION__IMPORT_URI = eINSTANCE.getImportDeclaration_ImportURI();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationScope <em>Scope</em>}' enum.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationScope
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getAdaptationScope()
		 * @generated
		 */
        EEnum ADAPTATION_SCOPE = eINSTANCE.getAdaptationScope();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.AdaptationDirection <em>Direction</em>}' enum.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationDirection
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getAdaptationDirection()
		 * @generated
		 */
        EEnum ADAPTATION_DIRECTION = eINSTANCE.getAdaptationDirection();

        /**
		 * The meta object literal for the '{@link edu.kit.ipd.descartes.mm.adaptation.RelationalOperator <em>Relational Operator</em>}' enum.
		 * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
		 * @see edu.kit.ipd.descartes.mm.adaptation.RelationalOperator
		 * @see edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationPackageImpl#getRelationalOperator()
		 * @generated
		 */
        EEnum RELATIONAL_OPERATOR = eINSTANCE.getRelationalOperator();

    }

} //AdaptationPackage
