/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.repository.impl;

import edu.kit.ipd.descartes.core.impl.EntityImpl;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyConnector;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyContext;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.ComposedStructure;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.ProvidingDelegationConnector;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RequiringDelegationConnector;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Composed Structure</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.ComposedStructureImpl#getAssemblyContexts <em>Assembly Contexts</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.ComposedStructureImpl#getAssemblyConnectors <em>Assembly Connectors</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.ComposedStructureImpl#getProvidingDelegationConnectors <em>Providing Delegation Connectors</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.ComposedStructureImpl#getRequiringDelegationConnectors <em>Requiring Delegation Connectors</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class ComposedStructureImpl extends EntityImpl implements ComposedStructure {
	/**
	 * The cached value of the '{@link #getAssemblyContexts() <em>Assembly Contexts</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAssemblyContexts()
	 * @generated
	 * @ordered
	 */
	protected EList<AssemblyContext> assemblyContexts;

	/**
	 * The cached value of the '{@link #getAssemblyConnectors() <em>Assembly Connectors</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAssemblyConnectors()
	 * @generated
	 * @ordered
	 */
	protected EList<AssemblyConnector> assemblyConnectors;

	/**
	 * The cached value of the '{@link #getProvidingDelegationConnectors() <em>Providing Delegation Connectors</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProvidingDelegationConnectors()
	 * @generated
	 * @ordered
	 */
	protected EList<ProvidingDelegationConnector> providingDelegationConnectors;

	/**
	 * The cached value of the '{@link #getRequiringDelegationConnectors() <em>Requiring Delegation Connectors</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRequiringDelegationConnectors()
	 * @generated
	 * @ordered
	 */
	protected EList<RequiringDelegationConnector> requiringDelegationConnectors;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedStructureImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RepositoryPackage.Literals.COMPOSED_STRUCTURE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<AssemblyContext> getAssemblyContexts() {
		if (assemblyContexts == null) {
			assemblyContexts = new EObjectContainmentWithInverseEList<AssemblyContext>(AssemblyContext.class, this, RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONTEXTS, RepositoryPackage.ASSEMBLY_CONTEXT__PARENT_STRUCTURE);
		}
		return assemblyContexts;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<AssemblyConnector> getAssemblyConnectors() {
		if (assemblyConnectors == null) {
			assemblyConnectors = new EObjectContainmentWithInverseEList<AssemblyConnector>(AssemblyConnector.class, this, RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONNECTORS, RepositoryPackage.ASSEMBLY_CONNECTOR__PARENT_STRUCTURE);
		}
		return assemblyConnectors;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ProvidingDelegationConnector> getProvidingDelegationConnectors() {
		if (providingDelegationConnectors == null) {
			providingDelegationConnectors = new EObjectContainmentWithInverseEList<ProvidingDelegationConnector>(ProvidingDelegationConnector.class, this, RepositoryPackage.COMPOSED_STRUCTURE__PROVIDING_DELEGATION_CONNECTORS, RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__PARENT_STRUCTURE);
		}
		return providingDelegationConnectors;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<RequiringDelegationConnector> getRequiringDelegationConnectors() {
		if (requiringDelegationConnectors == null) {
			requiringDelegationConnectors = new EObjectContainmentWithInverseEList<RequiringDelegationConnector>(RequiringDelegationConnector.class, this, RepositoryPackage.COMPOSED_STRUCTURE__REQUIRING_DELEGATION_CONNECTORS, RepositoryPackage.REQUIRING_DELEGATION_CONNECTOR__PARENT_STRUCTURE);
		}
		return requiringDelegationConnectors;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONTEXTS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getAssemblyContexts()).basicAdd(otherEnd, msgs);
			case RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONNECTORS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getAssemblyConnectors()).basicAdd(otherEnd, msgs);
			case RepositoryPackage.COMPOSED_STRUCTURE__PROVIDING_DELEGATION_CONNECTORS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getProvidingDelegationConnectors()).basicAdd(otherEnd, msgs);
			case RepositoryPackage.COMPOSED_STRUCTURE__REQUIRING_DELEGATION_CONNECTORS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getRequiringDelegationConnectors()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONTEXTS:
				return ((InternalEList<?>)getAssemblyContexts()).basicRemove(otherEnd, msgs);
			case RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONNECTORS:
				return ((InternalEList<?>)getAssemblyConnectors()).basicRemove(otherEnd, msgs);
			case RepositoryPackage.COMPOSED_STRUCTURE__PROVIDING_DELEGATION_CONNECTORS:
				return ((InternalEList<?>)getProvidingDelegationConnectors()).basicRemove(otherEnd, msgs);
			case RepositoryPackage.COMPOSED_STRUCTURE__REQUIRING_DELEGATION_CONNECTORS:
				return ((InternalEList<?>)getRequiringDelegationConnectors()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONTEXTS:
				return getAssemblyContexts();
			case RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONNECTORS:
				return getAssemblyConnectors();
			case RepositoryPackage.COMPOSED_STRUCTURE__PROVIDING_DELEGATION_CONNECTORS:
				return getProvidingDelegationConnectors();
			case RepositoryPackage.COMPOSED_STRUCTURE__REQUIRING_DELEGATION_CONNECTORS:
				return getRequiringDelegationConnectors();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONTEXTS:
				getAssemblyContexts().clear();
				getAssemblyContexts().addAll((Collection<? extends AssemblyContext>)newValue);
				return;
			case RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONNECTORS:
				getAssemblyConnectors().clear();
				getAssemblyConnectors().addAll((Collection<? extends AssemblyConnector>)newValue);
				return;
			case RepositoryPackage.COMPOSED_STRUCTURE__PROVIDING_DELEGATION_CONNECTORS:
				getProvidingDelegationConnectors().clear();
				getProvidingDelegationConnectors().addAll((Collection<? extends ProvidingDelegationConnector>)newValue);
				return;
			case RepositoryPackage.COMPOSED_STRUCTURE__REQUIRING_DELEGATION_CONNECTORS:
				getRequiringDelegationConnectors().clear();
				getRequiringDelegationConnectors().addAll((Collection<? extends RequiringDelegationConnector>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONTEXTS:
				getAssemblyContexts().clear();
				return;
			case RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONNECTORS:
				getAssemblyConnectors().clear();
				return;
			case RepositoryPackage.COMPOSED_STRUCTURE__PROVIDING_DELEGATION_CONNECTORS:
				getProvidingDelegationConnectors().clear();
				return;
			case RepositoryPackage.COMPOSED_STRUCTURE__REQUIRING_DELEGATION_CONNECTORS:
				getRequiringDelegationConnectors().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONTEXTS:
				return assemblyContexts != null && !assemblyContexts.isEmpty();
			case RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONNECTORS:
				return assemblyConnectors != null && !assemblyConnectors.isEmpty();
			case RepositoryPackage.COMPOSED_STRUCTURE__PROVIDING_DELEGATION_CONNECTORS:
				return providingDelegationConnectors != null && !providingDelegationConnectors.isEmpty();
			case RepositoryPackage.COMPOSED_STRUCTURE__REQUIRING_DELEGATION_CONNECTORS:
				return requiringDelegationConnectors != null && !requiringDelegationConnectors.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //ComposedStructureImpl
