/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.resourcelandscape;

import edu.kit.ipd.descartes.core.Entity;

import edu.kit.ipd.descartes.mm.containerrepository.ContainerTemplate;

import edu.kit.ipd.descartes.mm.resourceconfiguration.ConfigurationSpecification;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Container</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourcelandscape.Container#getContains <em>Contains</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourcelandscape.Container#getConfigSpec <em>Config Spec</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourcelandscape.Container#getTemplate <em>Template</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapePackage#getContainer()
 * @model abstract="true"
 * @generated
 */
public interface Container extends Entity {
	/**
     * Returns the value of the '<em><b>Contains</b></em>' containment reference list.
     * The list contents are of type {@link edu.kit.ipd.descartes.mm.resourcelandscape.RuntimeEnvironment}.
     * It is bidirectional and its opposite is '{@link edu.kit.ipd.descartes.mm.resourcelandscape.RuntimeEnvironment#getContainedIn <em>Contained In</em>}'.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Contains</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @return the value of the '<em>Contains</em>' containment reference list.
     * @see edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapePackage#getContainer_Contains()
     * @see edu.kit.ipd.descartes.mm.resourcelandscape.RuntimeEnvironment#getContainedIn
     * @model opposite="containedIn" containment="true"
     * @generated
     */
	EList<RuntimeEnvironment> getContains();

	/**
     * Returns the value of the '<em><b>Config Spec</b></em>' containment reference list.
     * The list contents are of type {@link edu.kit.ipd.descartes.mm.resourceconfiguration.ConfigurationSpecification}.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Config Spec</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @return the value of the '<em>Config Spec</em>' containment reference list.
     * @see edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapePackage#getContainer_ConfigSpec()
     * @model containment="true"
     * @generated
     */
	EList<ConfigurationSpecification> getConfigSpec();

	/**
     * Returns the value of the '<em><b>Template</b></em>' reference.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Template</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @return the value of the '<em>Template</em>' reference.
     * @see #setTemplate(ContainerTemplate)
     * @see edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapePackage#getContainer_Template()
     * @model
     * @generated
     */
	ContainerTemplate getTemplate();

	/**
     * Sets the value of the '{@link edu.kit.ipd.descartes.mm.resourcelandscape.Container#getTemplate <em>Template</em>}' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @param value the new value of the '<em>Template</em>' reference.
     * @see #getTemplate()
     * @generated
     */
	void setTemplate(ContainerTemplate value);

} // Container
