/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.usageprofile;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.RandomVariable;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Branch User Action</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.BranchUserAction#getBranches <em>Branches</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.BranchUserAction#getBranchingProbabilities <em>Branching Probabilities</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageProfilePackage#getBranchUserAction()
 * @model
 * @generated
 */
public interface BranchUserAction extends AbstractUserAction {
	/**
	 * Returns the value of the '<em><b>Branches</b></em>' containment reference list.
	 * The list contents are of type {@link edu.kit.ipd.descartes.mm.usageprofile.ScenarioBehavior}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Branches</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Branches</em>' containment reference list.
	 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageProfilePackage#getBranchUserAction_Branches()
	 * @model containment="true"
	 * @generated
	 */
	EList<ScenarioBehavior> getBranches();

	/**
	 * Returns the value of the '<em><b>Branching Probabilities</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Branching Probabilities</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Branching Probabilities</em>' containment reference.
	 * @see #setBranchingProbabilities(RandomVariable)
	 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageProfilePackage#getBranchUserAction_BranchingProbabilities()
	 * @model containment="true" required="true"
	 * @generated
	 */
	RandomVariable getBranchingProbabilities();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.usageprofile.BranchUserAction#getBranchingProbabilities <em>Branching Probabilities</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Branching Probabilities</em>' containment reference.
	 * @see #getBranchingProbabilities()
	 * @generated
	 */
	void setBranchingProbabilities(RandomVariable value);

} // BranchUserAction
