/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.usageprofile;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageProfilePackage
 * @generated
 */
public interface UsageProfileFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	UsageProfileFactory eINSTANCE = edu.kit.ipd.descartes.mm.usageprofile.impl.UsageProfileFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Usage Profile</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Usage Profile</em>'.
	 * @generated
	 */
	UsageProfile createUsageProfile();

	/**
	 * Returns a new object of class '<em>Usage Scenario</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Usage Scenario</em>'.
	 * @generated
	 */
	UsageScenario createUsageScenario();

	/**
	 * Returns a new object of class '<em>Scenario Behavior</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Scenario Behavior</em>'.
	 * @generated
	 */
	ScenarioBehavior createScenarioBehavior();

	/**
	 * Returns a new object of class '<em>Import</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Import</em>'.
	 * @generated
	 */
	Import createImport();

	/**
	 * Returns a new object of class '<em>Open Workload Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Open Workload Type</em>'.
	 * @generated
	 */
	OpenWorkloadType createOpenWorkloadType();

	/**
	 * Returns a new object of class '<em>Closed Workload Type</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Closed Workload Type</em>'.
	 * @generated
	 */
	ClosedWorkloadType createClosedWorkloadType();

	/**
	 * Returns a new object of class '<em>Loop User Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Loop User Action</em>'.
	 * @generated
	 */
	LoopUserAction createLoopUserAction();

	/**
	 * Returns a new object of class '<em>Delay User Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Delay User Action</em>'.
	 * @generated
	 */
	DelayUserAction createDelayUserAction();

	/**
	 * Returns a new object of class '<em>Branch User Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Branch User Action</em>'.
	 * @generated
	 */
	BranchUserAction createBranchUserAction();

	/**
	 * Returns a new object of class '<em>System Call User Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>System Call User Action</em>'.
	 * @generated
	 */
	SystemCallUserAction createSystemCallUserAction();

	/**
	 * Returns a new object of class '<em>Call Parameter Setting</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Call Parameter Setting</em>'.
	 * @generated
	 */
	CallParameterSetting createCallParameterSetting();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	UsageProfilePackage getUsageProfilePackage();

} //UsageProfileFactory
